scriptName DSerEnchantArrows extends activemagiceffect

;-- Properties --------------------------------------
globalvariable property MCM_ScalingWeight auto

DSerDeadlyArrowsMonitor property DeadlyArrowsMonitor auto

;Set for each spell
String property EnchantType auto

spell property EnchantedArrow_Type_Fire auto
spell property EnchantedArrow_Type_Ice auto
spell property EnchantedArrow_Type_Magic auto
spell property EnchantedArrow_Type_Shock auto
spell property EnchantedArrow_AmmoEquipped auto


function RemoveOtherTypes(Actor akTarget)
	if akTarget.HasSpell(EnchantedArrow_Type_Fire as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Fire)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Ice as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Ice)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Magic as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Magic)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Shock as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Shock)
	endIf
endFunction

;If the player already has the right spell on, reset it to refresh the FX
;Otherwise, just add the spell
Event OnEffectStart(Actor akTarget, Actor akCaster)
	if EnchantType == "Fire"
		if akTarget.HasSpell(EnchantedArrow_Type_Fire as form)
			DeadlyArrowsMonitor.ResetArrowFX(akTarget)
		else
			self.RemoveOtherTypes(akTarget)
			akTarget.AddSpell(EnchantedArrow_Type_Fire, false)
		endIf
	elseIf EnchantType == "Frost"
		if akTarget.HasSpell(EnchantedArrow_Type_Ice as form)
			DeadlyArrowsMonitor.ResetArrowFX(akTarget)
		else
			self.RemoveOtherTypes(akTarget)
			akTarget.AddSpell(EnchantedArrow_Type_Ice, false)
		endIf
	elseIf EnchantType == "Magic"
		if akTarget.HasSpell(EnchantedArrow_Type_Magic as form)
			DeadlyArrowsMonitor.ResetArrowFX(akTarget)
		else
			self.RemoveOtherTypes(akTarget)
			akTarget.AddSpell(EnchantedArrow_Type_Magic, false)
		endIf
	elseIf EnchantType == "Shock"
		if akTarget.HasSpell(EnchantedArrow_Type_Shock as form)
			DeadlyArrowsMonitor.ResetArrowFX(akTarget)
		else
			self.RemoveOtherTypes(akTarget)
			akTarget.AddSpell(EnchantedArrow_Type_Shock, false)
		endIf
	endIf
	
	if !akTarget.HasSpell(EnchantedArrow_AmmoEquipped as form)
		debug.Notification("No arrows equipped")
	endIf
	
	debug.Notification(((MCM_ScalingWeight.GetValue() * (akTarget.GetAV("Enchanting") as Int) as Float) as Int) as String + " " + EnchantType + " Damage Charged")
endEvent
