scriptName DSerEnchantedArrow_RechargeSpell extends activemagiceffect

;-- Properties --------------------------------------
actor property PlayerRef auto

globalvariable property MCM_ScalingWeight auto

armor property RingOfTheDragon auto
armor property RingOfTheWispmother auto
armor property RingOfAetherius auto
armor property RingOfTheWamasu auto

spell property EnchantedArrow_Type_Fire auto
spell property EnchantedArrow_Type_Ice auto
spell property EnchantedArrow_Type_Magic auto
spell property EnchantedArrow_Type_Shock auto

spell property EnchantedArrow_AmmoEquipped auto


function RemoveOtherTypes(actor akTarget)
	if akTarget.HasSpell(EnchantedArrow_Type_Fire as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Fire)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Ice as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Ice)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Magic as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Magic)
	endIf
	if akTarget.HasSpell(EnchantedArrow_Type_Shock as form)
		akTarget.RemoveSpell(EnchantedArrow_Type_Shock)
	endIf
endFunction


Event OnEffectStart(actor akTarget, actor akCaster)
	String EnchantType_2
	armor WornRing = akTarget.GetWornForm(64) as armor
	
	if WornRing == RingOfTheDragon
		self.RemoveOtherTypes(akTarget)
		akTarget.AddSpell(EnchantedArrow_Type_Fire, false)
		EnchantType_2 = "Fire"
	elseIf WornRing == RingOfTheWispmother
		self.RemoveOtherTypes(akTarget)
		akTarget.AddSpell(EnchantedArrow_Type_Ice, false)
		EnchantType_2 = "Frost"
	elseIf WornRing == RingOfAetherius
		self.RemoveOtherTypes(akTarget)
		akTarget.AddSpell(EnchantedArrow_Type_Magic, false)
		EnchantType_2 = "Magic"
	elseIf WornRing == RingOfTheWamasu
		self.RemoveOtherTypes(akTarget)
		akTarget.AddSpell(EnchantedArrow_Type_Shock, false)
		EnchantType_2 = "Shock"
	endIf
	
	if akTarget != PlayerRef
		Int counter = akTarget.GetNumItems()
		Bool SearchingForAmmoToEquip = false
		while counter > 0
			counter -= 1
			if !SearchingForAmmoToEquip
				if akTarget.IsEquipped(akTarget.GetNthForm(counter)) && akTarget.GetNthForm(counter).GetType() == 42
					akTarget.AddSpell(EnchantedArrow_AmmoEquipped, false)
					counter = -1
				endIf
				if counter == 0
					if akTarget.HasSpell(EnchantedArrow_AmmoEquipped as form)
						akTarget.RemoveSpell(EnchantedArrow_AmmoEquipped)
					endIf
					counter = akTarget.GetNumItems()
					SearchingForAmmoToEquip = true
				endIf
			elseIf akTarget.GetNthForm(counter).GetType() == 42
				akTarget.EquipItem(akTarget.GetNthForm(counter), true, false)
				akTarget.AddSpell(EnchantedArrow_AmmoEquipped, false)
				counter = -1
			endIf
		endWhile
	endIf
	
	if akTarget == PlayerRef
		debug.Notification(((MCM_ScalingWeight.GetValue() * (akTarget.GetAV("Enchanting") as Int) as Float) as Int) as String + " " + EnchantType_2 + " Damage Charged")
	endIf
endEvent
