scriptName DSerEnchantedArrow_RingEnchantment extends activemagiceffect

;-- Properties --------------------------------------
actor property PlayerRef auto

spell property EnchantedArrow_RechargeSpell auto
spell property EnchantedArrowFX auto
spell property EnchantedQuiverFX auto

armor property RingOfTheDragon auto
armor property RingOfTheWispmother auto
armor property RingOfAetherius auto
armor property RingOfTheWamasu auto

sound property RingOfTheDragonSD auto
sound property RingOfTheWispmotherSD auto
sound property RingOfAetheriusSD auto
sound property RingOfTheWamasuSD auto


Event OnEffectStart(actor akTarget, actor akCaster)
	armor WornRing = akTarget.GetWornForm(64) as armor
	
	if akTarget == PlayerRef
		if WornRing == RingOfTheDragon
			RingOfTheDragonSD.Play(akTarget as objectreference)
		elseIf WornRing == RingOfTheWispmother
			RingOfTheWispmotherSD.Play(akTarget as objectreference)
		elseIf WornRing == RingOfAetherius
			RingOfAetheriusSD.Play(akTarget as objectreference)
		elseIf WornRing == RingOfTheWamasu
			RingOfTheWamasuSD.Play(akTarget as objectreference)
		endIf
	endIf
	
	;Cast the Recharge Spell and add FX
	EnchantedArrow_RechargeSpell.Cast(akTarget as objectreference, akTarget as objectreference)
	if akTarget.HasSpell(EnchantedArrowFX as form) == false
		akTarget.AddSpell(EnchantedArrowFX, false)
	endIf
	if akTarget.HasSpell(EnchantedQuiverFX as form) == false
		akTarget.AddSpell(EnchantedQuiverFX, false)
	endIf
endEvent

Event OnEffectFinish(actor akTarget, actor akCaster)
	;Remove the FX
	debug.trace("[DSerAGO]Removing AGO FX")
	;debug.notification("[DSerAGO]Removing AGO FX")
	if akTarget.HasSpell(EnchantedArrowFX as form) == true
		akTarget.RemoveSpell(EnchantedArrowFX)
	endIf
	if akTarget.HasSpell(EnchantedQuiverFX as form) == true
		akTarget.RemoveSpell(EnchantedQuiverFX)
	endIf
endEvent
